REBOL
[Title: "NoteTank"
	file: %NoteTank.r
	Author: "J. Colineau"
	Date: "04-dec-2003"
	Version: 1.4.1
	comment: {
			1.1.0 version publique 
			1.2.0 recherches internet
			1.3.0 scripts, interprtation expressions rebol
			1.3.2 gestion des accents
			1.4.0 fichier complmentaire de rgles
			1.4.1 optimisation gestion des accents }]

rep-files: "files/"
fichier-dbase: %files/notes.txt
fichier-tel: %bases/annuaireorsay.txt
fichier-adr: %bases/adresses2004.csv
fichier-trad: %bases/Anglais-francais.txt
fichier-dic1: %bases/Anglais_Francais.wb
fichier-regles: %mes-regles.r

rep-scripts: "scripts/"
i-rec: 0

sans-accent: func [str /local str1] [
	str1: copy str
	substitutions: ["" "e" "" "e" "" "a" "" "e" "" "e" "" "c" "" "o" "" "u"]
	foreach [search value] substitutions [
		replace/all str1 search value
	]
	str1
]

noter: func [str /local record] [
	record: copy []
	append/only record now
	append/only record trim str
	append/only dbase record
	save-db dbase fichier-dbase
	i-rec: length? dbase]

chercher: func [str /local ir] [
	dbase: head dbase
	i-rec: 0
	ir: 0
	strsa: sans-accent trim str
	foreach record dbase [
		ir: ir + 1
		if found? find (sans-accent to-string record/2) strsa [i-rec: ir print record/2]
	]
]

effacer: func [indice] [
	if indice > 0 [
		print rejoin ["effacement " dbase/:indice]
		dbase-old: copy dbase
		dbase: at dbase indice
		remove dbase
		dbase: head dbase
		save-db dbase fichier-dbase
		i-rec: 0
	]
]

chercher-tel: func [str doc] [
	either exists? to-file doc [
		base: read/lines to-file doc] [print ["fichier " doc " non trouv"] exit]
		strsa: sans-accent trim str
	foreach record base [
		if found? find (sans-accent to-string record) strsa [rec: parse record none print [rec/1 rec/2 "  " rec/3 rec/4 rec/5]]
	]

]

traduire: func [str doc] [
	either exists? to-file doc [
		base: read/lines to-file doc] [print ["fichier " doc " non trouv"] exit]
		strsa: sans-accent trim str
	foreach record base [
		if found? find (sans-accent to-string record) strsa [print record]
	]
]

chercher-adresse: func [str doc] [
	{ format fichier: Numro;Nom;Prnom;Adresse1;CodePostal;Ville;Adresse2;CodePostal2;Ville2;
	TlphoneDomicile;TlphoneBureau;Notes;Voeux2002;Merci25ans;Voeux2003}
	either exists? to-file doc [
		base: read/lines to-file doc] [print ["fichier " doc " non trouv"] exit]
		strsa: sans-accent trim str
	base: next base
	foreach record base [
		if found? find (sans-accent to-string record) strsa [rec: parse/all record ";" print [rec/1 rec/2 "  " rec/3 rec/4 rec/5 rec/6 rec/7 rec/8 rec/9 rec/10 rec/11 rec/12]]
	]
]

charger-dic-freelang: func [file /local aa liste-mots] [
	aa: copy ""
	either exists? file [aa: read file] [print ["fichier " doc " non trouv"] exit]
	liste-mots: []
	forskip aa 84 [
		;bb: copy/part aa 84
		;append liste-mots rejoin [bb newline]
		bb: copy/part aa 32
		parse/all bb [copy bbb to "^(null)"] none
		cc: copy/part (skip aa 31) 52
		parse/all cc [copy ccc to "^(null)"] none
		append liste-mots rejoin [bbb "     " ccc newline]
	]
	liste-mots: head liste-mots
]

traduire1: func [str base] [
	{ pas au point !!!}
	str1: trim str
	foreach record base [
		if found? find (to-string record) str1 [print record]
	]
]

load-db: func [file] [
	either exists? file [load/all file] [copy []]
]

print-db: func [db] [
	foreach record db [
		print record/2
	]
]

save-db: func [db file /local out] [
	out: make string! 50 * length? db ; estimate
	foreach record db [
		append out trim/lines mold record
		append out newline
	]
	write file out
]

append-db: func [db str] [
	record: copy []
	append record rejoin [now]
	append record str
	append/only db record
]

change-db: func [file /local tmp tmp1] [
	i-rec: 0
	tmp: copy split-path to-file file
	tmp1: copy parse second tmp "."
	fichier-dbase: to-file rejoin [rep-files first tmp1 ".txt"]
	load-db fichier-dbase
]

regles: [
	[["noter dans le fichier     "] [["noter" | "note" | "-"] copy aa to end] [noter aa exit]]
	[["sauver et quitter		"] [["bye" | "quit" | "exit"] to end] [print "bye ..." save-db dbase fichier-dbase exit]]
	[["changer de fichier		"] [["cf" | "changer"] copy aa to end] [save-db dbase fichier-dbase dbase: change-db aa exit]]
	[["lister les fichiers		"] [["???" | "fichiers"] to end] [print read to-file rep-files exit]]
	[["fichier et dernier enreg "] [["??" | "fichier"] to end] [print [fichier-dbase "  " last dbase] exit]]
	[["chercher				"] [["?" | "chercher" | "trouver"] copy aa to end] [chercher aa exit]]
	[["chercher un n de tl     "] [["tel" | "tlphone"] copy aa to end] [chercher-tel aa fichier-tel exit]]
	[["chercher une adresse      "] [["adr" | "adresse"] copy aa to end] [chercher-adresse aa fichier-adr exit]]
	[["traduire			    "] [[">" | "traduire"] copy aa to end] [traduire aa fichier-trad exit]]
	[["afficher la date		"] [["jour" | "date"] to end] [print now/date exit]]
	[["afficher l'heure		"] [["heure"] to end] [print now/time exit]]
	[["expression Rebol		"] [["=" | "R "] copy aa to end] [if error? try [do reform aa] [print "expression mal formule"] exit]]
	[["imprimer l'aide			"] [["aide" | "help"] to end] [lister-regles exit]] ;[print aide-txt exit]]
	[["lister le fichier		"] ["lister" copy aa to end] [print-db dbase exit]]
	[["effacer un enregistr	"] ["effacer" copy aa to end] [effacer i-rec exit]]
	[["restaurer un effacement"] ["restaurer"] [dbase: copy dbase-old save-db dbase fichier-dbase exit]]
	[["version du logiciel		"] ["version"] [print ["NoteTank, version" system/script/header/version] exit]]
	[["diter le programme      "] ["editer"] [editor %noteTank.r do %notetank.r exit]]
	[["backup du fichier de notes"] [["backup"] to end] [fdb: copy fichier-dbase change find fdb ".txt" ".bak" save-db dbase fdb exit]]
]

if exists? fichier-regles [do fichier-regles append regles regles1]

lister-regles: func [] [
	print "----------------"
	print "commandes                       mots-cls"
	print ""
	foreach regle regles [
		print [regle/1 tab parse form regle/2/1 "|"]
	]
	print "----------------"
]

do-clean: func [str] [
	if error? try [aaa: do str] [aaa: ""]
	return aaa
]

input-parse: func [str /local blk lstr aa] [
	blk: copy str
	; test fin programme
	if parse blk [["bye" | "quit" | "exit"] to end] [print "bye ..." save-db dbase fichier-dbase break]
	; test rgles NoteTank
	foreach regle regles [
		if parse blk regle/2 regle/3]
	; test scripts
	if error? try [do to-file rejoin [rep-scripts blk ".r"] print "ok" exit] []
	; test expressions Rebol ...  peaufiner	
	if error? try [
		print do-clean blk
		exit] []
	; commande non comprise	
	print "?"
	i-rec: 0
]

; -------- dbut programme -------

if not exists? to-file rep-files [make-dir to-file rep-files]
dbase: load-db fichier-dbase


;cc: charger-dic-freelang to-file fichier-dic1
;write %bases/test.txt cc

print rejoin ["NoteTank, version " system/script/header/version]
print "--------"

forever [
	in-str: ask ">> "
	if error? try [input-parse in-str] [print "?"]
]